package com.jscape.inet.sftp.protocol.v4.marshaling;

import com.jscape.inet.sftp.protocol.messages.Message;
import com.jscape.inet.sftp.protocol.v4.messages.SshFxpClose;
import com.jscape.inet.ssh.protocol.v2.marshaling.primitive.StringCodec;
import com.jscape.inet.ssh.protocol.v2.marshaling.primitive.Uint32Codec;
import com.jscape.util.io.DataCodec;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/**
 * @author Alex Usun
 */
public class SshFxpCloseCodec
        implements DataCodec<Message> {

    @Override
    public Message read(InputStream in)
            throws IOException {
        int id = Uint32Codec.readValue(in);
        byte[] handle = StringCodec.readValue(in);

        return new SshFxpClose(id, handle);
    }

    @Override
    public void write(Message value, OutputStream out)
            throws IOException {
        SshFxpClose message = (SshFxpClose) value;
        Uint32Codec.writeValue(message.id, out);
        StringCodec.writeValue(message.handle, out);
    }

}
